#include "CinReader.h"

CinReader::CinReader(istream* in){
  this->in = in;
}

/* 
   pre: het is legaal om cin uit te lezen && !cin.eof() && chr != ESC
   post: cin.get(chr) wordt uitgevoerd. 
*/
bool CinReader::read(char& chr){
  in->get(chr);
  
  if(in->eof())
    return false;
  else if (in->fail() || in->bad())
    throw new IOException("Error reading input");

  // check for escape key
  return (chr != 27);
}

/* 
   pre: het is legaal om cin uit te lezen && len >= 0 && buffer heeft len char's
   post: cin.read(buffer, len) wordt uitgevoerd
*/
unsigned int CinReader::read(char * buffer, unsigned int len){
  in->read(buffer, len);

  if (!in->eof() && (in->fail() || in->bad()))
    throw new IOException("Error reading input");

  return (unsigned int)in->gcount();
}

/* 
   pre: het is legaal om cin uit te lezen
   post: buffer = new char[100] && cin.getline() wordt uitgevoerd
*/
unsigned int CinReader::readLine(char * buffer, unsigned int len){
  in->getline(buffer, len);

  if (!in->eof() && (in->fail() || in->bad()))
    throw new IOException("Error reading input");

  return (unsigned int)in->gcount();
}

void CinReader::close(){
}
