#include "Executrix.h"


Symbol* Executrix::execute(Expression* exp){
  ExpressionNode* node = exp->getRoot();

  if(node == NULL)
    return NULL;
  int arg = 0;

  while(node->getChildCount() > 0){
    if(arg < node->getChildCount()){

      ExpressionNode* child = node->getChild(arg);
      if(child->getChildCount() != 0){

	args_i.push(arg);
	node = child;
	arg = 0;
      }else
	arg++;
    }else{

      ExpressionNode* newnode = exp->createNode(getSymbol(node), 0);
			
      if(args_i.empty()){
	exp->setRoot(newnode);
	exp->destroy(node);
	node = exp->getRoot();
      }else{
	arg = args_i.top();
	args_i.pop();

	ExpressionNode* parent = node->parent;
 	exp->destroy(node);
	exp->insert(newnode, parent, arg);

	node = parent;
	arg++;
      }
    }
  }
  return node->symbol;
}

Symbol* Executrix::getSymbol(ExpressionNode* node){
  if(node->symbol->isType(Symbol::LPAR)){
    Symbol* s = node->getChild(0)->symbol;
    return s->getConstant();
    
  }else if(node->symbol->isType(Symbol::UNARY) || 
	   node->symbol->isType(Symbol::BINARY) || 
	   node->symbol->isType(Symbol::PREFIX)){
				
    Symbol* args[node->getChildCount()];
    for(int i=0; i < node->getChildCount(); i++)
      args[i] = node->getChild(i)->symbol;
								
    return ((Function*)node->symbol)->call(args, node->getChildCount());
  }
  return NULL;
}
