#ifndef __Executrix_h__
#define __Executrix_h__

class ExpressionNode;

#include <stack>
#include "Symbol.h"
#include "Expression.h"

using namespace std;

/*		Executrix
	De Executrix bestaat uit relatief weinig code. Het krijgt een boom structuur(Expression*)
	en geeft 1 Symbol* terug die de uitkomst van de expressie bevat.
	Het zoekt eerst naar een uitvoerbare vertakking. Dat is een vertakking waarvan alle 
	kinderen(vertakkingen) zelf 0 kinderen hebben. De Function Symbol* van die vertakking 
	wordt uitgevoerd en de vertakking wordt vervangen door een node met 0 kinderen waarvan 
	de Symbol* de uitkomst is van de functie. Daarna wordt weer verder gezocht naar andere
	van zulke vertakkingen, tot maar 1 node overblijft.
	De zoekmethode die gebruikt wordt is Depth First Search.
*/

class Executrix{
 private:
  stack<int> args_i;
  Symbol* getSymbol (ExpressionNode* node);

 public:
  Symbol* execute (Expression* exp);
  
};

#endif
