#ifndef __Expression_h__
#define __Expression_h__

#include <vector>
#include <string>
#include "Symbol.h"

using namespace std;

/*		Expression
		Deze class doet niets anders dan een boomstructuur beheersen. Met de Methoden kunnen
		nodes aangemaakt ingevoegd en vernietigd worden.
*/

class ExpressionNode{
 public:
  ExpressionNode* parent;
  Symbol* symbol;
  int childcount;
  ExpressionNode** children;
				
  ExpressionNode(Symbol* s, int childcount);
  ~ExpressionNode();
  ExpressionNode* clone();
		
  void setChild(int i, ExpressionNode* node);
  ExpressionNode* getChild(int i);
  int getChildCount();
};

class Expression{
 private:
  ExpressionNode* root;
  int lineno;
		
  void append(string* s, ExpressionNode* node);
		
 public:
  Expression(int linenumber);
  ~Expression();
  Expression* clone();
		
  ExpressionNode* getRoot();
  void setRoot(ExpressionNode*);
		
  ExpressionNode* createNode(Symbol* s, int childcount);
		
  void destroy(ExpressionNode* node);
  ExpressionNode* insert(ExpressionNode* node, ExpressionNode* parent, int branch);
  bool add(ExpressionNode* node, ExpressionNode* parent);
		
  int getLineNumber();
  string toString();
};
#endif
