#include "FileReader.h"

FileReader::FileReader(){
}

FileReader::FileReader(const char * filename){
  open(filename);
}

/* 
   pre:
   post: close() wordt uitgevoerd
*/
FileReader::~FileReader() {
  close();
}


bool FileReader::read(char& chr){
  file.get(chr);
  
  if(file.eof())
    return false;
  else if (file.fail() || file.bad())
    throw new IOException("Error reading input");
  
  return true;
}
	
/* 
   pre: isOpen() == true && len >= 0 && buffer heeft len chars
   post: file.read(buffer, len) wordt uitgevoerd
*/			
unsigned int FileReader::read(char * buffer, unsigned int len){
  file.read(buffer, len);
  if (!file.eof() && (file.fail() || file.bad()))
    throw new IOException("Error reading input");
  
  return file.gcount();
}

unsigned int FileReader::readLine(char* buffer, unsigned int len){
  file.getline(buffer, len);
  if (!file.eof() && (file.fail() || file.bad()))
    throw new IOException("Error reading input");
  
  return file.gcount();
}

/* 
   pre: isOpen() == true
   post: file.close() wordt uitgevoerd
*/			
void FileReader::close(){
  file.close();
}

/*
  pre: const char* file wijst naar een char array
  post: file.open(file) wordt uitgevoerd en isOpen wordt teruggegeven
*/
bool FileReader::open(const char* file){
  this->file.open(file);
  
  if (this->file.fail() || this->file.bad())
    throw new IOException("Error opening file");
  
  return this->file.good();
}

