#include "FileWriter.h"

FileWriter::FileWriter(){
}

FileWriter::FileWriter(const char* filename){
	file.open(filename, ios::out);
}

FileWriter::~FileWriter(){
	if(isOpen())
		close();
}

/*
	pre: filename wijst naar een char array
	post: file.open(filename, ios::out) wordt uitgevoerd en isOpen() wordt teruggegeven
*/
bool FileWriter::newFile(const char* filename){
	file.open(filename, ios::out);
	return isOpen();
}

/*
	pre: len >= 0 &&  l wijst naar een array van len chars
	post: file.write(l, len) wordt uitgevoerd en true wordt teruggegeven
*/
bool FileWriter::writeLine(const char* l, int len){
	if(isOpen()){
		file.write(l, len);
		return true;
	}else
		return false;
}

/*
	pre:
	post: file.good() wordt uitgevoerd en teruggegeven
*/
bool FileWriter::isOpen(){
	return file.good();
}
/*
	pre:
	post: file.close() wordt uitgevoerd
*/
void FileWriter::close(){
	file.close();
}
/*
	pre:
	post: close() wordt uitgevoerd
*/
void FileWriter::closeFile(){
	close();
}
