#include "List.h"

List::List(){
  head = NULL;
}
List::~List(){
  Node* n = head;
  while(n != NULL){
    Node* temp = n;
    n = n->next;
    temp->symbol->removePointer();
    delete temp;
  }
}

List::Node* List::getNode(const string name){
  Node* n = head;
  while(n != NULL){
    if(n->symbol->token.compare(name) == 0)
      return n;
    else
      n = n->next;
  }
  return NULL;
}


Symbol* List::insert(Symbol* item){
  item = item->getPointer();
  Node* node = getNode(item->token);
  if(node != NULL){
    node->symbol = item;
    return node->symbol;
  }else{
    head = new Node(head, item);
    return head->symbol;
  }
}
void List::remove(string item){
  Node* n = head;
  Node* parent = NULL;
  while(n != NULL){
    if(n->symbol->token.compare(item) == 0){
      if(n == head)
	head = n->next;
      else
	parent->next = n->next;

      n->symbol->removePointer();
      delete n;
      n = NULL;
    }else{
      parent = n;
      n = n->next;
    }
  }
}
Symbol* List::get(const string item){
  Node* node = getNode(item);
  if(node != NULL)
    return node->symbol;
  else
    return NULL;
}
void List::print(ostream& stream){
  Node* n = head;
  while(n != NULL){
    stream << n->symbol->toString();
    n = n->next;
  }
}

void List::clear(){
  Node* n = head;

  while(n != NULL){
    Node* temp = n;
    n = n->next;
    temp->symbol->removePointer();
    delete temp;
  }
  head = NULL;
}

