#ifndef __List_h__
#define __List_h__

#include <string>
#include <iostream>
#include "Symbol.h"

using namespace std;

/*		List
		Dit is een gelinkte lijst. Het bevat nodes die aan elkaar gelinkt zijn en waarin Symbol*
		pointers zijn opgeslagen. De lijst is makkelijker uitbereidbaar maar minder doorzoekbaar
		in vergelijking met een array.
*/


class List{
 private:
  struct Node{
    Node(Node* node, Symbol* s){
      symbol = s;
      next = node;
    }
    Symbol* symbol;
    Node* next;
  };
		
  Node* head;
  Node* getNode(const string name);
		
 public:
  List();
  ~List();
  Symbol* insert(Symbol* item);
  void remove(string item);
  Symbol* get(const string item);
  void print(ostream& stream);
  void clear();
};

#endif
