#ifndef __Tokenizer_h__
#define __Tokenizer_h__

#include <ctype.h>
#include <stdlib.h>
#include <string>
#include "Reader.h"
#include "FileReader.h"

using namespace std;


/**
 * Leest char's uit een implementatie van Reader en herkent de typen zoals
 * hieronder aangegeven. Er worden char's gelezen totdat het laastgelezen char
 * een ander type heeft dan de vorigen. Spaties worden niet gezien als token. In
 * een getal mag ook een punt voorkomen.
 *
 * Met getTokenType() kan het type van het token gelezen worden en met
 * getToken() kan een pointer naar het token verkregen worden.
 *
 * Elke keer als de Tokenizer een End Of Line(TT_EOL) token tegenkomt word
 * lineno met 1 verhoogd.
 */
class Tokenizer {
public:
  enum tokenType{NUMBER, WORD, UNKOWN, WHITESPACE, EOL, EOS};
	
  Tokenizer(Reader * reader);
		
  ~Tokenizer();
  
  int readNextToken();
  string* nextToken();
		
  void chop(string::size_type len);
  
  string* getToken();
  tokenType getTokenType();
  
  int getLineNumber();
  int getPosition();
		
private:
  Reader * in;
		
  string currentToken;
  tokenType currentTokenType;
						
  int lineNum, position;
  
  void IDchar();
  bool readNumber();
  bool readNumber(bool pointUsed);
		
protected:
  tokenType lastReadType;
  char lastRead;
};

#endif
